import {
  __name
} from "./chunk-Q3KE6ACF.mjs";

// src/use-event-listener.ts
import { unref, watch } from "vue";
import { isString, noop } from "@chakra-ui/utils";
import { defaultWindow, tryOnScopeDispose } from "@chakra-ui/vue-utils";
function useEventListener(...args) {
  let target;
  let event;
  let listener;
  let options;
  if (isString(args[0])) {
    ;
    [event, listener, options] = args;
    target = defaultWindow;
  } else {
    ;
    [target, event, listener, options] = args;
  }
  if (!target)
    return noop;
  let cleanup = noop;
  const stopWatch = watch(() => unref(target), (el) => {
    cleanup();
    if (!el)
      return;
    el.addEventListener(event, listener, options);
    cleanup = /* @__PURE__ */ __name(() => {
      el.removeEventListener(event, listener, options);
      cleanup = noop;
    }, "cleanup");
  }, {
    immediate: true,
    flush: "post"
  });
  const stop = /* @__PURE__ */ __name(() => {
    stopWatch();
    cleanup();
  }, "stop");
  tryOnScopeDispose(stop);
  return stop;
}
__name(useEventListener, "useEventListener");

export {
  useEventListener
};
