import {
  __name
} from "./chunk-Q3KE6ACF.mjs";

// src/use-element-stack.ts
import {
  inject,
  provide,
  watchEffect
} from "vue";
var StackContext = Symbol("ChakraElementStackContext");
var StackMessage = /* @__PURE__ */ ((StackMessage2) => {
  StackMessage2[StackMessage2["AddElement"] = 0] = "AddElement";
  StackMessage2[StackMessage2["RemoveElement"] = 1] = "RemoveElement";
  return StackMessage2;
})(StackMessage || {});
function useStackContext() {
  return inject(StackContext, () => {
  });
}
__name(useStackContext, "useStackContext");
function useElementStack(element) {
  let notify = useStackContext();
  watchEffect((onInvalidate) => {
    let domElement = element == null ? void 0 : element.value;
    if (!domElement)
      return;
    notify(0 /* AddElement */, domElement);
    onInvalidate(() => notify(1 /* RemoveElement */, domElement));
  });
}
__name(useElementStack, "useElementStack");
function useStackProvider(onUpdate) {
  let parentUpdate = useStackContext();
  function notify(...args) {
    onUpdate == null ? void 0 : onUpdate(...args);
    parentUpdate(...args);
  }
  __name(notify, "notify");
  provide(StackContext, notify);
}
__name(useStackProvider, "useStackProvider");

export {
  StackMessage,
  useStackContext,
  useElementStack,
  useStackProvider
};
