import {
  useEventListener
} from "./chunk-5KFONQLM.mjs";
import {
  __name
} from "./chunk-Q3KE6ACF.mjs";

// src/use-clipboard.ts
import { ref, unref } from "vue";
function useClipboard({
  source,
  copyTimeout = 1e3,
  read = false
}) {
  const isSupported = Boolean(navigator && "clipboard" in navigator);
  const text = ref("");
  const copied = ref(false);
  const timeout = /* @__PURE__ */ __name(() => {
    let t = setTimeout(() => {
      copied.value = false;
    }, copyTimeout);
  }, "timeout");
  const events = ["copy", "cut"];
  if (isSupported && read) {
    for (const event of events)
      useEventListener(event, updateText);
  }
  function updateText() {
    navigator.clipboard.readText().then((value) => {
      text.value = value;
    });
  }
  __name(updateText, "updateText");
  async function copy(_value = unref(source)) {
    const value = unref(_value);
    if (isSupported && value != null) {
      await navigator.clipboard.writeText(value);
      text.value = value;
      copied.value = true;
      timeout();
    }
  }
  __name(copy, "copy");
  return {
    copy,
    text,
    copied
  };
}
__name(useClipboard, "useClipboard");

export {
  useClipboard
};
