import {
  __name
} from "./chunk-Q3KE6ACF.mjs";

// src/use-window-event.ts
import { watchEffect } from "vue";
function useWindowEvent(type, listener, options) {
  if (typeof window === "undefined")
    return;
  watchEffect((onInvalidate) => {
    window.addEventListener(type, listener, options);
    onInvalidate(() => {
      window.removeEventListener(type, listener, options);
    });
  });
}
__name(useWindowEvent, "useWindowEvent");

export {
  useWindowEvent
};
