import {
  __name
} from "./chunk-Q3KE6ACF.mjs";

// src/use-id.ts
import { canUseDOM } from "@chakra-ui/utils";
import { computed, onBeforeMount, onMounted, ref } from "vue";
var serverHandoffComplete = canUseDOM();
var _id = 0;
var genId = /* @__PURE__ */ __name(() => ++_id, "genId");
var useId = /* @__PURE__ */ __name((id, prefix) => {
  const initialId = id || (serverHandoffComplete ? genId() : null);
  const uid = ref(initialId);
  onBeforeMount(() => {
    if (serverHandoffComplete === false) {
      serverHandoffComplete = true;
    }
  });
  onMounted(() => {
    if (uid.value === null) {
      uid.value = genId();
    }
  });
  return computed(() => {
    const __id__ = uid.value !== null ? uid.value.toString() : void 0;
    return prefix ? `${prefix}-${__id__}` : __id__;
  });
}, "useId");
function useIds(id, ...prefixes) {
  const __id__ = useId(id);
  return prefixes.map((prefix) => computed(() => `${prefix}-${__id__.value}`));
}
__name(useIds, "useIds");

export {
  useId,
  useIds
};
