import {
  useId
} from "./chunk-OGYT5CBC.mjs";
import {
  __name
} from "./chunk-Q3KE6ACF.mjs";

// src/use-disclosure.ts
import { computed, ref, watchEffect } from "vue";
function useDisclosure(props = {}) {
  const {
    isOpen: isOpenProp,
    onClose: handleClose,
    onOpen: handleOpen,
    id: idProp,
    defaultIsOpen
  } = props;
  const isOpenState = ref(defaultIsOpen || false);
  const isOpen = ref(isOpenProp !== void 0 ? isOpenProp : isOpenState.value);
  const isControlled = isOpenProp !== void 0;
  const uid = useId();
  const id = computed(() => idProp != null ? idProp : `disclosure-${uid.value}`);
  const close = /* @__PURE__ */ __name(() => {
    if (!isControlled) {
      isOpenState.value = false;
    }
    handleClose == null ? void 0 : handleClose();
  }, "close");
  const open = /* @__PURE__ */ __name(() => {
    if (!isControlled) {
      isOpenState.value = true;
    }
    handleOpen == null ? void 0 : handleOpen();
  }, "open");
  const toggle = /* @__PURE__ */ __name(() => isOpen.value ? close() : open(), "toggle");
  const buttonProps = computed(() => ({
    "aria-expanded": isOpen.value,
    "aria-controls": id.value,
    onClick() {
      toggle();
    }
  }));
  const disclosureProps = computed(() => ({
    hidden: !isOpen.value,
    id: id.value
  }));
  watchEffect(() => {
    isOpen.value = isOpenState.value;
  });
  return {
    isOpen,
    open,
    close,
    toggle,
    isControlled,
    buttonProps,
    disclosureProps
  };
}
__name(useDisclosure, "useDisclosure");

export {
  useDisclosure
};
