"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/use-clipboard.ts
var use_clipboard_exports = {};
__export(use_clipboard_exports, {
  useClipboard: () => useClipboard
});
module.exports = __toCommonJS(use_clipboard_exports);
var import_vue2 = require("vue");

// src/use-event-listener.ts
var import_vue = require("vue");
var import_utils = require("@chakra-ui/utils");
var import_vue_utils = require("@chakra-ui/vue-utils");
function useEventListener(...args) {
  let target;
  let event;
  let listener;
  let options;
  if ((0, import_utils.isString)(args[0])) {
    ;
    [event, listener, options] = args;
    target = import_vue_utils.defaultWindow;
  } else {
    ;
    [target, event, listener, options] = args;
  }
  if (!target)
    return import_utils.noop;
  let cleanup = import_utils.noop;
  const stopWatch = (0, import_vue.watch)(() => (0, import_vue.unref)(target), (el) => {
    cleanup();
    if (!el)
      return;
    el.addEventListener(event, listener, options);
    cleanup = /* @__PURE__ */ __name(() => {
      el.removeEventListener(event, listener, options);
      cleanup = import_utils.noop;
    }, "cleanup");
  }, {
    immediate: true,
    flush: "post"
  });
  const stop = /* @__PURE__ */ __name(() => {
    stopWatch();
    cleanup();
  }, "stop");
  (0, import_vue_utils.tryOnScopeDispose)(stop);
  return stop;
}
__name(useEventListener, "useEventListener");

// src/use-clipboard.ts
function useClipboard({
  source,
  copyTimeout = 1e3,
  read = false
}) {
  const isSupported = Boolean(navigator && "clipboard" in navigator);
  const text = (0, import_vue2.ref)("");
  const copied = (0, import_vue2.ref)(false);
  const timeout = /* @__PURE__ */ __name(() => {
    let t = setTimeout(() => {
      copied.value = false;
    }, copyTimeout);
  }, "timeout");
  const events = ["copy", "cut"];
  if (isSupported && read) {
    for (const event of events)
      useEventListener(event, updateText);
  }
  function updateText() {
    navigator.clipboard.readText().then((value) => {
      text.value = value;
    });
  }
  __name(updateText, "updateText");
  async function copy(_value = (0, import_vue2.unref)(source)) {
    const value = (0, import_vue2.unref)(_value);
    if (isSupported && value != null) {
      await navigator.clipboard.writeText(value);
      text.value = value;
      copied.value = true;
      timeout();
    }
  }
  __name(copy, "copy");
  return {
    copy,
    text,
    copied
  };
}
__name(useClipboard, "useClipboard");
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  useClipboard
});
