"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/use-disclosure.ts
var use_disclosure_exports = {};
__export(use_disclosure_exports, {
  useDisclosure: () => useDisclosure
});
module.exports = __toCommonJS(use_disclosure_exports);
var import_vue2 = require("vue");

// src/use-id.ts
var import_utils = require("@chakra-ui/utils");
var import_vue = require("vue");
var serverHandoffComplete = (0, import_utils.canUseDOM)();
var _id = 0;
var genId = /* @__PURE__ */ __name(() => ++_id, "genId");
var useId = /* @__PURE__ */ __name((id, prefix) => {
  const initialId = id || (serverHandoffComplete ? genId() : null);
  const uid = (0, import_vue.ref)(initialId);
  (0, import_vue.onBeforeMount)(() => {
    if (serverHandoffComplete === false) {
      serverHandoffComplete = true;
    }
  });
  (0, import_vue.onMounted)(() => {
    if (uid.value === null) {
      uid.value = genId();
    }
  });
  return (0, import_vue.computed)(() => {
    const __id__ = uid.value !== null ? uid.value.toString() : void 0;
    return prefix ? `${prefix}-${__id__}` : __id__;
  });
}, "useId");

// src/use-disclosure.ts
function useDisclosure(props = {}) {
  const {
    isOpen: isOpenProp,
    onClose: handleClose,
    onOpen: handleOpen,
    id: idProp,
    defaultIsOpen
  } = props;
  const isOpenState = (0, import_vue2.ref)(defaultIsOpen || false);
  const isOpen = (0, import_vue2.ref)(isOpenProp !== void 0 ? isOpenProp : isOpenState.value);
  const isControlled = isOpenProp !== void 0;
  const uid = useId();
  const id = (0, import_vue2.computed)(() => idProp != null ? idProp : `disclosure-${uid.value}`);
  const close = /* @__PURE__ */ __name(() => {
    if (!isControlled) {
      isOpenState.value = false;
    }
    handleClose == null ? void 0 : handleClose();
  }, "close");
  const open = /* @__PURE__ */ __name(() => {
    if (!isControlled) {
      isOpenState.value = true;
    }
    handleOpen == null ? void 0 : handleOpen();
  }, "open");
  const toggle = /* @__PURE__ */ __name(() => isOpen.value ? close() : open(), "toggle");
  const buttonProps = (0, import_vue2.computed)(() => ({
    "aria-expanded": isOpen.value,
    "aria-controls": id.value,
    onClick() {
      toggle();
    }
  }));
  const disclosureProps = (0, import_vue2.computed)(() => ({
    hidden: !isOpen.value,
    id: id.value
  }));
  (0, import_vue2.watchEffect)(() => {
    isOpen.value = isOpenState.value;
  });
  return {
    isOpen,
    open,
    close,
    toggle,
    isControlled,
    buttonProps,
    disclosureProps
  };
}
__name(useDisclosure, "useDisclosure");
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  useDisclosure
});
