"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/use-element-stack.ts
var use_element_stack_exports = {};
__export(use_element_stack_exports, {
  StackMessage: () => StackMessage,
  useElementStack: () => useElementStack,
  useStackContext: () => useStackContext,
  useStackProvider: () => useStackProvider
});
module.exports = __toCommonJS(use_element_stack_exports);
var import_vue = require("vue");
var StackContext = Symbol("ChakraElementStackContext");
var StackMessage = /* @__PURE__ */ ((StackMessage2) => {
  StackMessage2[StackMessage2["AddElement"] = 0] = "AddElement";
  StackMessage2[StackMessage2["RemoveElement"] = 1] = "RemoveElement";
  return StackMessage2;
})(StackMessage || {});
function useStackContext() {
  return (0, import_vue.inject)(StackContext, () => {
  });
}
__name(useStackContext, "useStackContext");
function useElementStack(element) {
  let notify = useStackContext();
  (0, import_vue.watchEffect)((onInvalidate) => {
    let domElement = element == null ? void 0 : element.value;
    if (!domElement)
      return;
    notify(0 /* AddElement */, domElement);
    onInvalidate(() => notify(1 /* RemoveElement */, domElement));
  });
}
__name(useElementStack, "useElementStack");
function useStackProvider(onUpdate) {
  let parentUpdate = useStackContext();
  function notify(...args) {
    onUpdate == null ? void 0 : onUpdate(...args);
    parentUpdate(...args);
  }
  __name(notify, "notify");
  (0, import_vue.provide)(StackContext, notify);
}
__name(useStackProvider, "useStackProvider");
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  StackMessage,
  useElementStack,
  useStackContext,
  useStackProvider
});
