"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/use-event-listener.ts
var use_event_listener_exports = {};
__export(use_event_listener_exports, {
  useEventListener: () => useEventListener
});
module.exports = __toCommonJS(use_event_listener_exports);
var import_vue = require("vue");
var import_utils = require("@chakra-ui/utils");
var import_vue_utils = require("@chakra-ui/vue-utils");
function useEventListener(...args) {
  let target;
  let event;
  let listener;
  let options;
  if ((0, import_utils.isString)(args[0])) {
    ;
    [event, listener, options] = args;
    target = import_vue_utils.defaultWindow;
  } else {
    ;
    [target, event, listener, options] = args;
  }
  if (!target)
    return import_utils.noop;
  let cleanup = import_utils.noop;
  const stopWatch = (0, import_vue.watch)(() => (0, import_vue.unref)(target), (el) => {
    cleanup();
    if (!el)
      return;
    el.addEventListener(event, listener, options);
    cleanup = /* @__PURE__ */ __name(() => {
      el.removeEventListener(event, listener, options);
      cleanup = import_utils.noop;
    }, "cleanup");
  }, {
    immediate: true,
    flush: "post"
  });
  const stop = /* @__PURE__ */ __name(() => {
    stopWatch();
    cleanup();
  }, "stop");
  (0, import_vue_utils.tryOnScopeDispose)(stop);
  return stop;
}
__name(useEventListener, "useEventListener");
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  useEventListener
});
