"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/use-id.ts
var use_id_exports = {};
__export(use_id_exports, {
  useId: () => useId,
  useIds: () => useIds
});
module.exports = __toCommonJS(use_id_exports);
var import_utils = require("@chakra-ui/utils");
var import_vue = require("vue");
var serverHandoffComplete = (0, import_utils.canUseDOM)();
var _id = 0;
var genId = /* @__PURE__ */ __name(() => ++_id, "genId");
var useId = /* @__PURE__ */ __name((id, prefix) => {
  const initialId = id || (serverHandoffComplete ? genId() : null);
  const uid = (0, import_vue.ref)(initialId);
  (0, import_vue.onBeforeMount)(() => {
    if (serverHandoffComplete === false) {
      serverHandoffComplete = true;
    }
  });
  (0, import_vue.onMounted)(() => {
    if (uid.value === null) {
      uid.value = genId();
    }
  });
  return (0, import_vue.computed)(() => {
    const __id__ = uid.value !== null ? uid.value.toString() : void 0;
    return prefix ? `${prefix}-${__id__}` : __id__;
  });
}, "useId");
function useIds(id, ...prefixes) {
  const __id__ = useId(id);
  return prefixes.map((prefix) => (0, import_vue.computed)(() => `${prefix}-${__id__.value}`));
}
__name(useIds, "useIds");
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  useId,
  useIds
});
