"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/use-media-query.ts
var use_media_query_exports = {};
__export(use_media_query_exports, {
  useMediaQuery: () => useMediaQuery
});
module.exports = __toCommonJS(use_media_query_exports);
var import_vue_utils2 = require("@chakra-ui/vue-utils");

// src/use-supported.ts
var import_vue_utils = require("@chakra-ui/vue-utils");
var import_vue = require("vue");
function useSupported(callback, sync = false) {
  const isSupported = (0, import_vue.ref)();
  const update = /* @__PURE__ */ __name(() => isSupported.value = Boolean(callback()), "update");
  update();
  (0, import_vue_utils.tryOnMounted)(update, sync);
  return isSupported;
}
__name(useSupported, "useSupported");

// src/use-media-query.ts
var import_vue2 = require("vue");
function useMediaQuery(query, options = {}) {
  const {
    window = import_vue_utils2.defaultWindow
  } = options;
  const isSupported = useSupported(() => window && "matchMedia" in window && typeof window.matchMedia === "function");
  let mediaQuery;
  const matches = (0, import_vue2.ref)(false);
  const cleanup = /* @__PURE__ */ __name(() => {
    if (!mediaQuery)
      return;
    if ("removeEventListener" in mediaQuery)
      mediaQuery.removeEventListener("change", update);
    else
      mediaQuery.removeListener(update);
  }, "cleanup");
  const update = /* @__PURE__ */ __name(() => {
    if (!isSupported.value)
      return;
    cleanup();
    mediaQuery = window.matchMedia((0, import_vue_utils2.resolveRef)(query).value);
    matches.value = mediaQuery.matches;
    if ("addEventListener" in mediaQuery)
      mediaQuery.addEventListener("change", update);
    else
      mediaQuery.addListener(update);
  }, "update");
  (0, import_vue2.watchEffect)(update);
  (0, import_vue_utils2.tryOnScopeDispose)(() => cleanup());
  return matches;
}
__name(useMediaQuery, "useMediaQuery");
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  useMediaQuery
});
